Texture Texture0;
Texture Texture1;
Texture Texture2;
Texture Texture3;

Technique ps_1_1
{
    Pass P0
	{
		PixelShader			= asm
		{
			TEMP r0, r1;
			ATTRIB f0 = fragment.texcoord[0];
			ATTRIB f1 = fragment.texcoord[1];
			ATTRIB f2 = fragment.texcoord[2];
			ATTRIB f3 = fragment.texcoord[3];
			ATTRIB v0 = fragment.color.primary;

			TEMP t0, t1, t2, t3;
			TEX t0, f0, texture[0], 2D;
			TEX t1, f1, texture[1], 2D;
			TEX t2, f2, texture[2], 2D;
			TEX t3, f3, texture[3], 2D;
			OUTPUT oC0 = result.color;

			PARAM one = { 1.0, 1.0, 1.0, 1.0 };
			PARAM half = { 0.5, 0.5, 0.5, 0.5 };
			PARAM two = { 2.0, 2.0, 2.0, 2.0 };
			
			TEMP oneminus;
			SUB oneminus.a, one.a, t0.a;
			
			# environment type = normal
			# we could have used lrp here, but you can only read 2 texture registers per instruction
			MUL r0.rgb, t0.a, t1;				# detail map part 1
			MUL r0.a, t0.a, t1.a;				# detail specular mask part 1
#DAJ		MAD r0.rgb, 1-t0.a, t2, r0;			# detail map part 2
			MAD r0.rgb, oneminus.a, t2, r0;			# detail map part 2
#DAJ		MAD r0.a, 1-t0.a, t2.a, r0.a;		# detail specular mask part 2
			MAD r0.a, oneminus.a, t2.a, r0.a;		# detail specular mask part 2

			TEMP r0_bx2;
			SUB r0_bx2, r0, half;
			MUL r0_bx2, r0_bx2, two;

			# detail map function
			ADD r0.rgb, t0, r0_bx2;				# biased add
			MUL r0.a, t0.a, r0.a;				# Modulate specular mask by base map alpha

			# micro detail map function
			MUL r0.rgb, t3, r0;				# multiply
			MUL r0.a, t3.a, r0.a;
			
			MOV     oC0, r0;	#DAJ save off
		};
 	}
}

Technique ps_0_0
{
    Pass P0
	{
		Texture[0]			= (Texture0);
		Texture[1]			= (Texture1);

		ColorOp[0]			= SelectArg1;
		ColorArg1[0]		= Texture;
		AlphaOp[0]			= SelectArg1;
		AlphaArg1[0]		= Texture;

		ColorOp[1]			= Modulate;
		ColorArg1[1]		= Current;
		ColorArg2[1]		= Texture;
		AlphaOp[1]			= SelectArg1;
		AlphaArg1[1]		= Texture;
		AlphaArg2[1]		= Current;

		ColorOp[2]			= Disable;
		AlphaOp[2]			= Disable;

		PixelShader			= Null;
 	}
}

Technique fallback
{
    Pass P0
	{
		ColorOp[0]			= Modulate;
		ColorArg1[0]		= Texture;
		ColorArg2[0]		= Diffuse;
		AlphaOp[0]			= SelectArg1;
		AlphaArg1[0]		= Texture;

		ColorOp[1]			= Disable;
		AlphaOp[1]			= Disable;

		PixelShader			= Null;
	}
}
