!!ARBvp1.0
TEMP r0, r1, r2, r3, r4, r5, r6, r7, r8, r9, r10, r11;
PARAM c[96] = { program.env[0..95] };
ALIAS oPos = result.position;
ALIAS oD0 = result.color.primary;
ALIAS oD1 = result.color.secondary;
ALIAS oT0 = result.texcoord[0];
ALIAS oT1 = result.texcoord[1];
ALIAS oT2 = result.texcoord[2];
ALIAS oT3 = result.texcoord[3];

ADDRESS a0;

ATTRIB v0 = vertex.attrib[0];
ATTRIB v1 = vertex.attrib[1];
ATTRIB v2 = vertex.attrib[2];
ATTRIB v3 = vertex.attrib[3];
ATTRIB v4 = vertex.attrib[4];
ATTRIB v5 = vertex.attrib[5];
ATTRIB v6 = vertex.attrib[6];

#DAJ defaults
MOV oD0, c[95].w;
MOV oT0, c[95];
MOV oT1, c[95];
MOV oT2, c[95];
MOV oT3, c[95];
MOV oD1, c[95].w;

# (10) build blended transform (2 nodes) ------------------------------------------------
MUL r0.xy, v5, c[9].w;
ADD r0.xy, r0, c[5].w;
ARL a0.x, r0.x;
MUL r4, v6.x, c[a0.x + 29];
MUL r5, v6.x, c[a0.x + 30];
MUL r6, v6.x, c[a0.x + 31];
ARL a0.x, r0.y;
MAD r4, v6.y, c[a0.x + 29], r4;
MAD r5, v6.y, c[a0.x + 30], r5;
MAD r6, v6.y, c[a0.x + 31], r6;

# (4) transform position ----------------------------------------------------------------
DP4 r0.x, v0, r4;
DP4 r0.y, v0, r5;
DP4 r0.z, v0, r6;
MOV r0.w, v4.w; # necessary because we can't use DPH

# (6) transform normal ------------------------------------------------------------------
DP3 r1.x, v1, r4;
DP3 r1.y, v1, r5;
DP3 r1.z ,v1, r6;
DP3 r1.w, r1, r1;
RSQ r1.w, r1.w;
MUL r1.xyz, r1, r1.w;

# (1) compute eye vector ----------------------------------------------------------------
ADD r5.xyz, -r0, c[4];

# (3) compute reflection vector ---------------------------------------------------------
DP3 r6.x, r5, r1;
MUL r6.xyz, r6.x, r1;
MAD r6.xyz, r6.xyzz, c[4].w, -r5; 

# (4) output homogeneous point ----------------------------------------------------------
DP4 oPos.x, r0, c[0];
DP4 oPos.y, r0, c[1];
DP4 oPos.z, r0, c[2];
DP4 oPos.w, r0, c[3];

# (12) output texcoords -----------------------------------------------------------------
# we have to compute the z- axis by the cross product of the x- and y- axes
MOV r11, c[14];
MUL r10, c[13].yzxw, r11.zxyw;
MAD r10,-r11.yzxw, c[13].zxyw, r10;
DP3 oT0.x, r1, c[13];
DP3 oT0.y, r1, c[14];
DP3 oT0.z, r1, r10;
DP4 oT1.x, v4, c[15];
DP4 oT1.y, v4, c[16];
DP4 oT2.x, v4, c[17];
DP4 oT2.y, v4, c[18];
DP4 oT3.x, v4, c[19];
DP4 oT3.y, v4, c[20];

# (2) atmospheric fog ----------------------------------------------------------------
DP4 r8.z, r0, c[6];
MUL r8.z, r8.z, c[9].x;
SUB r8.z, v4.w, r8.z;

# (6) fade ------------------------------------------------------------------------------
# PERF: we don't always need all this crap
DP3 r10.x, v1, -c[5];
MAX r10.x, r10.x, -r10.x;
ADD r10.y, v4.w, -r10.x;
MUL oD0.w, r8.z, c[12].z; # no fade
MUL oD1.xyzw, r10.xxxy, c[12].z; # fade-when-perpendicular(w), parallel(xyz)

END
